/*
    remote-sensor, a wireless sensor data collection system
    Copyright (C) 2008  christian mock <cm@tahina.priv.at>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

/* find the device: */
#define USB_VENDOR 0x16C0
#define USB_PRODUCT 0x05DC
#define USB_MANUF_STRING "www.tahina.priv.at"
#define USB_PRODUCT_STRING "Sensor"
#define USB_PRODUCT_VERSION 0x0200 // BCD

// in case the receiver disappears from the bus, in what intervals (seconds)
// do we try to re-open it?
#define USB_REOPEN_TIMEOUT 10 

#define REQ_ECHO   0
#define REQ_STATUS 1
#define REQ_STATS  2
#define REQ_READ   3

#define MAX_PKT_SIZE 255

#define STRINGSZ 256

struct message {
  uint8_t sender;
  uint8_t seq;
  uint8_t data[MAX_PKT_SIZE - 2];
} __attribute__ ((packed));

struct sensor_reading {
  uint8_t len:2;
  uint8_t type:6;
  union {
    uint8_t one;
    uint16_t two;
    uint32_t four;
  } data;
} __attribute__((packed));

//#define raw2voltage(raw) (1.10 / ((raw)/1024.0))

